#version 110

attribute vec3 inVertex;
attribute vec3 inTextureCoord;

uniform mat4 modelViewProjectionMatrix;
uniform vec2 screenSize;

varying vec2 textureCoord;

void main() {
  vec4 ssPosition  = modelViewProjectionMatrix * vec4( inVertex, 1.0 );
  vec2 ndcPosition = ( ssPosition.xy / screenSize ) * 2.0 - 1.0;
  gl_Position      = vec4( ndcPosition, 0.0, 1.0 );
  textureCoord     = inTextureCoord.xy;
}
