#version 110

varying vec2 textureCoord;

uniform sampler2D textureAlbedo;
uniform vec3      screenGamma;
uniform float     exposureLevel;
uniform float     alphaTestThreshold;
uniform bool      isColor;
uniform vec4      color;
uniform float     opacity;
uniform bool      isSky;

void main() {
  if ( isSky ) {
    return;
  }
  vec4 colorLinear;
  if ( isColor ) {
    colorLinear = color;
  } else {
    colorLinear = texture2D( textureAlbedo, textureCoord );
  }
  float alpha = min( colorLinear.a, opacity );
  if ( alpha < alphaTestThreshold ) {
    discard;
  }
  vec3 mapped  = vec3( 1.0 ) - exp( -colorLinear.rgb * exposureLevel );
  gl_FragColor = vec4( pow( mapped, screenGamma ), alpha );
}
