#version 150 core

layout( std140 ) uniform Matrices {
  mat4 viewProjectionMatrix;
  mat4 viewProjectionInversedMatrix;
};

out vec3 textureCoord;

void main() {
  // преобразуем координаты полноэкранного квадрата в координаты кубической карты
  vec2 pos   = vec2( ( gl_VertexID & 2 ) >> 1, 1 - ( gl_VertexID & 1 ) ) * 2.0f - 1.0f;
  vec4 front = viewProjectionInversedMatrix * vec4( pos, -1.0f, 1.0f );
  vec4 back  = viewProjectionInversedMatrix * vec4( pos, 1.0f, 1.0f );

  textureCoord = back.xyz / back.w - front.xyz / front.w;
  // особенность кубических карт Dark Engine
  textureCoord = vec3( textureCoord.x, -textureCoord.y, -textureCoord.z );

  gl_Position = vec4( pos, 1.0f, 1.0f );
}
